#include<math.h>
#define SIZE 50
typedef unsigned int size_t;

typedef int bool;
#define false 0
#define true 1

#define PI 3.14159265359

#define Pow(A) ((A)*(A))

#define OFFSET_OF(type, member) ((size_t)&(((type *)0)->member))
enum
  {
    SimCellType_Space,
    SimCellType_Obsticle,
  };

typedef struct
{
  float x;
  float y;
}v2;

typedef struct
{
  float ParticleCount;
  v2 Velocity;
  int Type;
}sim_cell;

void PrintMatrix(sim_cell *Matrix, int From , int To);
void CopyCell(sim_cell *Source, sim_cell *Dest);
void Update(v2 Acceleration, int x, int y, int xo, int yo, sim_cell *Cells, sim_cell *TempCells, bool PrintVector);
void CalcPressureAcceleration(v2 *Acceleration, sim_cell *Cells, int ProcessRank, int RowsPerProcess, int x, int y, int xOffset, int yOffset);

//
//######################################################################
//

// Vector Stuff

v2 V2(float x, float y)
{
  v2 Result = {x,y};

  return Result;
}

v2 add(v2 LHS, v2 RHS)
{
  v2 result = {};

  result.x = LHS.x + RHS.x;
  result.y = LHS.y + RHS.y;

  return result;
}

v2 sub(v2 LHS, v2 RHS)
{
  v2 result = {};

  result.x = LHS.x - RHS.x;
  result.y = LHS.y - RHS.y;

  return result;
}

v2 scale(float LHS, v2 RHS)
{
  v2 result = {};

  result.x = LHS * RHS.x;
  result.y = LHS * RHS.y;

  return result;
}

v2 hadamard(v2 LHS, v2 RHS)
{
  v2 Result = {};

  Result.x = LHS.x * RHS.x;
  Result.y = LHS.y * RHS.y;

  return Result;
}

float LengthSquared(v2 Vector)
{
  float result = (Pow(Vector.x)+Pow(Vector.y));

  return result;
}

float Length(v2 Vector)
{
  float result = sqrt(LengthSquared(Vector));

  return result;
}

//
//###################################################################
//

// Helper functions

float Abs(float Value)
{
	float Result = Value;
	if(Result < 0)
	{
		Result *= (-1);
	}  
	return Result;
}

float RadToDeg(float Rad)
{
	float result = ((Rad * 180.0f)/PI);
	
	return (result);
}

float Clamp01(float Value)
{
	float Result = Value;

	if(Result > 1){Result = 1;}
	if(Result < 0){Result = 0;}

	return Result;
}

float MapIntoRangeClamped01(float Min, float Max, float Value)
{
	float Result = 0;
  
	float MinMax = (Max+Min);
	if(MinMax)
	{
		Result = (1/(Min+Max))*Value + (1/(Min+Max))*Min;
	}
	Result = Clamp01(Result);
  
	return Result;
}
